



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>requests模块的cookie和代理操作</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">requests模块的cookie和代理操作</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 02:21:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一.基于requests模块的cookie操作</h2>
<p>引言：有些时候，我们在使用爬虫程序去爬取一些用户相关信息的数据（爬取张三&ldquo;人人网&rdquo;个人主页数据）时，如果使用之前requests模块常规操作时，往往达不到我们想要的目的，</p>
<p>例如：</p>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python

# -*- coding:utf-8 -*-

import requests

if __name__ == "__main__":

    #张三人人网个人信息页面的url

    url = 'http://www.renren.com/289676607/profile'

   #伪装UA

    headers={<br />
        'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36',<br />
    }

    #发送请求，获取响应对象

    response = requests.get(url=url,headers=headers)

    #将响应内容写入文件

    with open('./renren.html','w',encoding='utf-8') as fp:

        fp.write(response.text)
</pre>
</div>
<p>- 结果发现，写入到文件中的数据，不是张三个人页面的数据，而是人人网登陆的首页面，why？首先我们来回顾下cookie的相关概念及作用：</p>
<p>　　　　- cookie概念：当用户通过浏览器首次访问一个域名时，访问的web服务器会给客户端发送数据，以保持web服务器与客户端之间的状态保持，这些数据就是cookie。</p>
<p>　　　　- cookie作用：我们在浏览器中，经常涉及到数据的交换，比如你登录邮箱，登录一个页面。我们经常会在此时设置30天内记住我，或者自动登录选项。那么它们是怎么记录信息的呢，答案就是今天的主角cookie了，Cookie是由HTTP服务器设置的，保存在浏览器中，但HTTP协议是一种无状态协议，在数据交换完毕后，服务器端和客户端的链接就会关闭，每次交换数据都需要建立新的链接。就像我们去超市买东西，没有积分卡的情况下，我们买完东西之后，超市没有我们的任何消费信息，但我们办了积分卡之后，超市就有了我们的消费信息。cookie就像是积分卡，可以保存积分，商品就是我们的信息，超市的系统就像服务器后台，http协议就是交易的过程。</p>
<p>- 经过cookie的相关介绍，其实你已经知道了为什么上述案例中爬取到的不是张三个人信息页，而是登录页面。那应该如何抓取到张三的个人信息页呢？</p>
<p>　　思路：</p>
<p>　　　　1.我们需要使用爬虫程序对人人网的登录时的请求进行一次抓取，获取请求中的cookie数据</p>
<p>　　　　2.在使用个人信息页的url进行请求时，该请求需要携带 1 中的cookie，只有携带了cookie后，服务器才可识别这次请求的用户信息，方可响应回指定的用户信息页数据</p>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python

# -*- coding:utf-8 -*-

import requests

if __name__ == "__main__":

    #登录请求的url（通过抓包工具获取）

    post_url = 'http://www.renren.com/ajaxLogin/login?1=1&amp;uniqueTimestamp=201873958471'

    #创建一个session对象，该对象会自动将请求中的cookie进行存储和携带

    session = requests.session()

   #伪装UA

    headers={<br />
        'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36',<br />
    }

    formdata = {

        'email': '17701256561',

        'icode': '',

        'origURL': 'http://www.renren.com/home',

        'domain': 'renren.com',

        'key_id': '1',

        'captcha_type': 'web_login',

        'password': '7b456e6c3eb6615b2e122a2942ef3845da1f91e3de075179079a3b84952508e4',

        'rkey': '44fd96c219c593f3c9612360c80310a3',

        'f': 'https%3A%2F%2Fwww.baidu.com%2Flink%3Furl%3Dm7m_NSUp5Ri_ZrK5eNIpn_dMs48UAcvT-N_kmysWgYW%26wd%3D%26eqid%3Dba95daf5000065ce000000035b120219',

    }

    #使用session发送请求，目的是为了将session保存该次请求中的cookie

    session.post(url=post_url,data=formdata,headers=headers)

    get_url = 'http://www.renren.com/960481378/profile'

    #再次使用session进行请求的发送，该次请求中已经携带了cookie

    response = session.get(url=get_url,headers=headers)

    #设置响应内容的编码格式

    response.encoding = 'utf-8'

    #将响应内容写入文件

    with open('./renren.html','w') as fp:

        fp.write(response.text)
</pre>
</div>
<h3>登录豆瓣获取首页</h3>
<div>
<pre class="prettyprint linenums">import requests<br />
session = requests.session()<br />
# 1 发起登录请求：将cookie获取，且存储到session对象中<br />
login_url = 'https://accounts.douban.com/login'<br />
data = {<br />
    "source":"None",<br />
    "redir":"https://www.douban.com/people/185687620/",<br />
    "form_email":"15027900535",<br />
    "form_password":"bobo@15027900535",<br />
    "login":"登录",<br />
}<br />
agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36'<br />
headers = {<br />
    'User-Agent': agent,<br />
}<br />
# 使用session发起post请求<br />
login_response = session.post(url=login_url,data=data,headers=headers)<br />
# 2 对个人主页发起请求（session(cookie)）,获取响应页面数据<br />
url = 'https://www.douban.com/people/185687620/'<br />
response = session.get(url=url,headers=headers)<br />
page_text = response.text<br />
with open('./douban110.html','w',encoding='utf-8') as fp:<br />
    fp.write(page_text)
</pre>
</div>
<h2>二.基于requests模块的代理操作</h2>
<ul><li>什么是代理</p>
<ul><li><p>代理就是第三方代替本体处理相关事务。例如：生活中的代理：代购，中介，微商......</p></li></ul></li>
<li><p>爬虫中为什么需要使用代理</p>
<ul><li><p>一些网站会有相应的反爬虫措施，例如很多网站会检测某一段时间某个IP的访问次数，如果访问频率太快以至于看起来不像正常访客，它可能就会会禁止这个IP的访问。所以我们需要设置一些代理IP，每隔一段时间换一个代理IP，就算IP被禁止，依然可以换个IP继续爬取。</p></li></ul></li>
<li><p>代理的分类：</p>
<ul><li><p>正向代理：代理客户端获取数据。正向代理是为了保护客户端防止被追究责任。</p></li>
<li><p>反向代理：代理服务器提供数据。反向代理是为了保护服务器或负责负载均衡。</p></li></ul></li>
<li><p>免费代理ip提供网站</p>
<ul><li><p>http://www.goubanjia.com/</p></li>
<li><p>西祠代理-https://www.xicidaili.com/nn/</p></li>
<li><p>快代理-https://www.kuaidaili.com/free/</p></li></ul></li>
<li><p>代码</p></li></ul>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python

# -*- coding:utf-8 -*-

import requests

import random

if __name__ == "__main__":

    #不同浏览器的UA

    header_list = [

        # 遨游

        {"user-agent": "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; Maxthon 2.0)"},

        # 火狐

        {"user-agent": "Mozilla/5.0 (Windows NT 6.1; rv:2.0.1) Gecko/20100101 Firefox/4.0.1"},

        # 谷歌

        {

            "user-agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_0) AppleWebKit/535.11 (KHTML, like Gecko) Chrome/17.0.963.56 Safari/535.11"}<br />
    ]

    #不同的代理IP

    proxy_list = [

        {"http": "112.115.57.20:3128"},

        {'http': '121.41.171.223:3128'}

    ]

    #随机获取UA和代理IP

    header = random.choice(header_list)

    proxy = random.choice(proxy_list)

    url = 'http://www.baidu.com/s?ie=UTF-8&amp;wd=ip'

    #参数3：设置代理

    response = requests.get(url=url,headers=header,proxies=proxy)

    response.encoding = 'utf-8'

    with open('daili.html', 'wb') as fp:

        fp.write(response.content)

    #切换成原来的IP

    requests.get(url, proxies={"http": ""})
</pre>
</div>
<p><em><strong>注意：代理的请求头和爬取的url应一致（如都是&ldquo;https&rdquo;）</strong> </em></p>
<p>代理访问百度：</p>
<div>
<pre class="prettyprint linenums">import urllib.request<br />
import urllib.parse

handler = urllib.request.ProxyHandler(proxies={'http':'116.196.121.56:8080'})<br />
opener = urllib.request.build_opener(handler)<br />
url='https://www.baidu.com/s?ie=utf-8&amp;f=8&amp;rsv_bp=0&amp;rsv_idx=1&amp;tn=baidu&amp;wd=ip'<br />
headers={<br />
    'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36'<br />
}<br />
request = urllib.request.Request(url,headers=headers)

response = opener.open(request)<br />
print(response.read())
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93w700q.html">ArchLinux&plus;Win10双系统的Grub配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/495jp2zq.html">初识Polymer框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rm42m8.html">javascript 红宝书笔记之函数、变量、参数、作用域</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxx1neq.html">在页面头部&amp;lt&semi;&excl;DOCTYPE html  &period;&period;&period;&period;&amp;gt&semi; 前面不能有任何输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k64j5q.html">try catch finally的一些用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mgd028.html">Nmap备忘单：从探索到漏洞利用（Part 5）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8moeyo9.html">HTML5 挖宝</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdopyr8.html">Git工作流指南：Gitflow工作流 Comparing Workflows</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yw1y0q.html">fedora21安装xmind7</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd24mk8.html">verilog流水线加法器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j0k6v8.html">GitHub客户端Desktop的安装和使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv137lyq.html">vue初级学习--控制台创建vue项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj214r8.html">react图工具集成</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eydgkm9.html">nginx&plus;tomcat：动静分离&plus;https</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvv0dk8.html">冒泡 MS Azure 不便宜。。。</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wj270q.html">【AGC006C】Rabbit Exercise 置换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1n0og9.html">Python模块之time、random、os、sys、序列化、re</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv22og8.html">sklearn机器学习-泰坦尼克号</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5kxkmq.html">Javascript高级编程学习笔记（5）&mdash;&mdash; JS操作符</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w405zq.html">Javascript this 的一些总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95go27eq.html">c&plus;&plus;内存泄漏原因及解决办法（智能指针）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvop028.html">Python time &amp;amp&semi; datetime模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw2nev9.html">day4  大纲笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j13y2w9.html">java中length与length&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4vpxk9.html">MQTT压力测试工具之JMeter插件教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5xjpeq.html">Zookeeper watcher机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv24vdx9.html">php上传导入文件 nginx-502错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r6rpj9.html">WPF DataGrid 用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjojl09.html">ul或者ol中添加li元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5vnk7q.html">在vue项目中 获取容器的高度</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
